package ipipe;
/*
 * LogPane.java
 *
 * Created on February 6, 2003, 7:57 AM
 */
import javax.swing.*;
import javax.swing.text.*;
import javax.swing.text.StyleConstants;
/**
 *
 * @author  jrobertson
 */
public class LogPane extends javax.swing.JTextPane  {
    
    /** Creates a new instance of LogPane */
    public LogPane() {
        initStyles();
    }
    
        private void log(String s, javax.swing.text.AttributeSet attribs) {
          /*  sb.append("<font color='" + c + "'>");
            sb.append(s);
            sb.append("</font><br>");
            console.setText( sb.toString()); */
            try {
                getDocument().insertString(
                    getDocument().getLength(),
                    s,
                    attribs
                    );
                toEnd();
            } catch (Exception e) {
                e.printStackTrace();
            }
        }
        
        private void logln(String s, javax.swing.text.AttributeSet attribs) {
            log(s+"\n", attribs);
        }

        Style defaultStyle = StyleContext.getDefaultStyleContext().
                                        getStyle(StyleContext.DEFAULT_STYLE);        
        
        Style clientText = addStyle("clientText",  defaultStyle);

        Style clientBinary = addStyle("clientBinary",  clientText);
        
        
        Style serverText = addStyle("serverText", defaultStyle);

        Style serverBinary = addStyle("serverText", serverText);
        
        
        Style errorText = addStyle("errorText", defaultStyle);

        
        void initStyles() {
            StyleConstants.setForeground(clientText, java.awt.Color.blue);
            StyleConstants.setForeground(errorText, java.awt.Color.red);
            
            StyleConstants.setForeground(clientBinary, java.awt.Color.white);
            StyleConstants.setBackground(clientBinary, java.awt.Color.blue);

            StyleConstants.setForeground(serverBinary, java.awt.Color.white);
            StyleConstants.setBackground(serverBinary, java.awt.Color.black);
            
            StyleConstants.setFontFamily(serverText, "Monospaced");
            StyleConstants.setFontFamily(clientText, "Monospaced");
            StyleConstants.setFontFamily(errorText, "Monospaced");
        }
        
        
        public final static int CLIENT = 0;
        public final static int SERVER = 1;
        public final static int ERROR = 2;

        
        public void log(String s, int type, boolean binary) {
            switch(type) {
                case CLIENT:
                    if(binary)
                        log(s, clientBinary );
                    else
                        log(s, clientText);
                    break;
                case SERVER:
                    if(binary)
                        log(s, serverBinary );
                    else
                        log(s, serverText);
                    
                    break;
                case ERROR:
                    log(s, errorText);
                    break;
            }
        }
    
    class GuiOutputStream extends java.io.OutputStream {
        
        int type;
        
        public GuiOutputStream(int type) {
            this.type = type;
        }
        
        public void write(int c) throws java.io.IOException {
           
            if(isPrintable(c)) {
                log( String.valueOf((char) c), type, false);
            } else {
                log( hex(c), type, true);
            }
        }

/*        public void write(byte[] values, int param, int param2) throws java.io.IOException {
            String s = new String(values, param,param2);
            log( s, type);
        }

        public void write(byte[] values) throws java.io.IOException {
            String s = new String(values);
            log(s,type);
        } */
        
        private boolean isPrintable(int c) {
            if(c == 9)
                return true;
            if(c == 0xd)
                return true;
            if(c == 0xa)
                return true;
            if(c >= 32 && c<127)
                return true;
            
            return false;
        }
        
        private String hex(int c) {
            String h = Integer.toHexString(c);
            if(h.length() == 1)
                h = "0"+h;
            return h;
        }
        
    }       
    
    public java.io.OutputStream getClientLog() {
        return new GuiOutputStream(CLIENT);
    }

    public java.io.OutputStream getServerLog() {
        return new GuiOutputStream(SERVER);
    }
    
    public java.io.OutputStream getErrorLog() {
        return new GuiOutputStream(ERROR);
    }
    
    private void toEnd() {
        java.awt.Rectangle visib = getVisibleRect();
        java.awt.Rectangle bound = getBounds();

        java.awt.Rectangle rect = new java.awt.Rectangle();
        rect.x = 0;//bound.width - visib.width;
        rect.y = bound.height - visib.height;
        rect.height = visib.height;
        rect.width = visib.width;

        //Only if there's scrolling possible
        if(bound.height > visib.height) {
                scrollRectToVisible(rect);
        }    
    }
}
