/*
 * Main.java
 *
 * Created on December 9, 2004, 10:12 AM
 */

package ipipe;

import java.net.*;
import java.io.*;

/**
 *
 * @author  jRobertson
 */
public class Main {
    
    /** Creates a new instance of Main */
    public Main() {
    }
    
    
    /**
     * @param args the command line arguments
     */
    public static void main(String[] args) throws java.io.IOException {
        // TODO code application logic here
        
        if( System.getProperty("listenPort") == null) {
            IPipeGui.main(args);
        } else {
        
            int listenPort = Integer.parseInt( System.getProperty("listenPort"));
            String destHost = System.getProperty("remoteHost");
            int destPort = Integer.parseInt(System.getProperty("remotePort"));

            String logFileName = System.getProperty("log");
            String clientLogFileName = System.getProperty("clientLog");
            String serverLogFileName = System.getProperty("serverLog");

            PrintStream clientLog, serverLog;

            if(logFileName == null ) {

                if(clientLogFileName ==  null) {
                    clientLog = null;
                } else if (clientLogFileName.equals("-")) {
                    clientLog = System.out;
                } else {
                    clientLog = new PrintStream( new FileOutputStream(clientLogFileName));
                }

                if(serverLogFileName ==  null) {
                    serverLog = null;
                } else if (serverLogFileName.equals("-")) {
                    serverLog = System.out;
                } else if (serverLogFileName.equals(clientLogFileName)){
                    serverLog = clientLog;
                } else {
                    serverLog = new PrintStream( new FileOutputStream(serverLogFileName));
                }
            } else {

                if (logFileName.equals("-")) {
                    clientLog = serverLog = System.out;
                } else {
                    clientLog = serverLog = new PrintStream( new FileOutputStream(logFileName));
                }

            }

            boolean serverSSL = "true".equals(System.getProperty("serverSSL"));
            boolean clientSSL = "true".equals(System.getProperty("clientSSL"));

            
            IPipe pipe = new IPipe(listenPort, destHost, destPort, clientLog, serverLog, System.err);

            if( System.getProperty("serverBuffer") != null) {
                pipe.setServerBuffer(Integer.parseInt(System.getProperty("serverBuffer")));
            }
            
            if( System.getProperty("clientBuffer") != null) {
                pipe.setClientBuffer(Integer.parseInt(System.getProperty("clientBuffer")));
            }
            
            pipe.setClientSSL(clientSSL);
            pipe.setServerSSL(serverSSL);

            pipe.listen();
        }        
    }
    
}
